#ifndef _IIC_H
#define _IIC_H
#include "CH57x_common.h"
#include "core_cm0.h"

#ifdef __cplusplus
extern "C"
{
#endif
	
extern volatile unsigned char i2c0_busy;	//i2c߷æ־

void i2c_write_single_byte(uint8_t port,uint8_t i2c_buff);
uint8_t i2c_read_single_byte(uint8_t port);
uint8_t i2c_ack_check(uint8_t port,uint8_t ctrl_byte);
void i2c_send_nack(uint8_t port);
void i2c_send_ack(uint8_t port);
uint8_t i2c_read_ack(uint8_t port);
void i2c_stop(uint8_t port);
void i2c_start(uint8_t port);
void i2c_init(uint8_t port);
void delay_us(uint16_t time);

uint8_t i2c_write_multi_byte(uint8_t port,uint8_t addr,uint8_t reg_width ,uint16_t reg_addr, uint8_t *buff,uint16_t len);
uint8_t i2c_read_multi_byte(uint8_t port,uint8_t addr,uint8_t reg_width ,uint16_t reg_addr, uint8_t *buff,uint16_t len);
#ifdef __cplusplus
}
#endif
#endif

