#ifndef __TIMER_H
#define __TIMER_H
#include <stdint.h>
#include <stddef.h>
#include "CH57x_common.h"
#include "core_cm0.h"

#define  TMR3_GetCurrentCount()		R32_TMR3_COUNT	 				/* ȡǰֵ67108864 */

// PWM
#define TMR3_PWMCycleCfg( cyc )	    (R32_TMR3_CNT_END=cyc)			/* PWM0 ͨ, 67108864 */
void TMR3_PWMInit( PWMX_PolarTypeDef pr, PWM_RepeatTsTypeDef ts );	/* PWM ʼ */	 
#define TMR3_PWMActDataWidth( d )   (R32_TMR3_FIFO = d)			/* PWM0 Ч, 67108864 */
	 
// ׽
#define TMR3_CAPTimeoutCfg( cyc )   (R32_TMR3_CNT_END=cyc)			/* CAP0 ׽ƽʱ, 33554432 */
void TMR3_CapInit( CapModeTypeDef cap );							/* ⲿźŲ׽ܳʼ */
#define TMR3_CAPGetData()			R32_TMR3_FIFO					/* ȡ */
#define TMR3_CAPDataCounter()		R8_TMR3_FIFO_COUNT				/* ȡǰѲݸ */


#define TMR3_Disable()				(R8_TMR3_CTRL_MOD &= ~RB_TMR_COUNT_EN)		/* ر TMR3 */
// refer to TMR3 interrupt bit define
#define	TMR3_ITCfg(s,f)				((s)?(R8_TMR3_INTER_EN|=f):(R8_TMR3_INTER_EN&=~f))		/* TMR3 Ӧжλر */
// refer to TMR3 interrupt bit define
#define TMR3_ClearITFlag(f)         (R8_TMR3_INT_FLAG = f)			/* жϱ־ */
#define TMR3_GetITFlag(f)           (R8_TMR3_INT_FLAG&f)			/* ѯжϱ־״̬ */

void InitTimer3(uint32_t time);

#endif
