#include "virtual_timer.h"

/* ڴ˶ɸʱȫֱ
ע⣬volatileΪжϺͬʱ
ʣпɱŻDelayMS
*/

volatile SOFT_TMR g_Tmr[SOFT_TMR_COUNT];
//洢 ǰtask id ȫֱ
tmosTaskID  timer_task_id = INVALID_TASK_ID;


//taskeventص,Ҫעtaskʱ,ȥ
static uint16_t timer_task_process_event( uint8_t task_id, uint16_t events ) 
{
	//event 
    if(events & TIMER_TASK_TMOS_EVT_TEST_1) 
    {
        SoftTimerRun();
        return (events ^ TIMER_TASK_TMOS_EVT_TEST_1); //ķʽ¼б־δе¼־       
    }

}

/*
ʼʱ
*/
void InitVirtualTimer(void)
{
	int a=SOFT_TMR_COUNT;
	while(--a)
	{
		g_Tmr[a].autorestart=0;  //ǷԶ¿ʼfunΪNULLʱЧ
		g_Tmr[a].count=0;    /*  */
		g_Tmr[a].flag=1;     /* ʱ־  */
		g_Tmr[a].fun=NULL;		/* ʱص*/
		g_Tmr[a].reload=0;  /* ֵ */
		g_Tmr[a].run=0;     //б־
	}
	
	//timer_task_id  = TMOS_ProcessEventRegister( timer_task_process_event );
	//ʼһʱevent
     //tmos_start_task(timer_task_id,TIMER_TASK_TMOS_EVT_TEST_1,16);			//16*625uS = 10mS


}

/*
ʱже
*/
void SoftTimerRun(void)
{
	uint8_t i=0;
	for(;i<SOFT_TMR_COUNT;i++)
	{
		SoftTimerDec(i);
	}
}


/*******************************************************************************
	SoftTimerDec
	  : ʱָ,ÿ1ms1
	  :
	˵
	0: DelayMSʹ
	1: UART0ճʱʱ
	2Զʱ
*/
void SoftTimerDec(uint8_t _tmr)
{
	if(_tmr>=SOFT_TMR_COUNT) return;
	if (g_Tmr[_tmr].flag==0 && g_Tmr[_tmr].run)	//ʱδʱ
	{
		if (g_Tmr[_tmr].count--==0)	//count--Ϊ0ʱ
		{
			g_Tmr[_tmr].flag=1;
			g_Tmr[_tmr].run=0;
			if(g_Tmr[_tmr].fun!=NULL)	//ִлص
			{
				g_Tmr[_tmr].fun();
				if (g_Tmr[_tmr].autorestart)
				{
					g_Tmr[_tmr].count=g_Tmr[_tmr].reload;
					g_Tmr[_tmr].flag=0;
					g_Tmr[_tmr].run=1;
				}
			}
		}
	}

}

/*******************************************************************************
	DelayMS
	  : ӳٳȣλ1 ms. ӳپΪ1ms
	  :
	˵ʱռʱ0
*/
void DelayMS(uint32_t n)
{
	/*  n = 1  */
	if (n == 1)
	{
		n = 2;
	}
	g_Tmr[0].count = n;
	g_Tmr[0].reload=n;
	g_Tmr[0].flag = 0;
	g_Tmr[0].fun=NULL;
	g_Tmr[0].autorestart=NULL;
	g_Tmr[0].run=1;

	/* while ѭCPUIDLE״̬ѽ͹ */
	while (1)
	{
		CPU_IDLE();
		if (g_Tmr[0].flag == 1)
		{
			break;
		}
	}
}

/*******************************************************************************
	StartTimer
	  : ʱID (0 - x),Ԥװؼֵ,صǷԶ
	  :
	˵
*/
void StartTimer(uint8_t _id, uint32_t _period, void* fun,uint8_t autorestart)
{
	g_Tmr[_id].count=_period;
	g_Tmr[_id].reload=_period;
	g_Tmr[_id].flag=0;
	g_Tmr[_id].run=1;
	g_Tmr[_id].fun=fun;
	g_Tmr[_id].autorestart=autorestart;
}

/*******************************************************************************
	CheckTimer
	  : ʱID (0 - x)
	  :  0 ʾʱδ 1ʾʱ
	˵
*/
uint8_t CheckTimer(uint8_t _id)
{
	if(g_Tmr[_id].flag)
	 	return 1;
	else
		return 0;
}


/*******************************************************************************
	TimerIsRun
	  : ʱID (0 - x)
	  :  0 ʾδУ 1ʾ
	˵鶨ʱǷ״̬
*/
uint8_t TimerIsRuning(uint8_t _id)
{
	if(g_Tmr[_id].run)
	 	return 1;
	else
		return 0;
}

/*******************************************************************************
	PauseTimer
	  : ʱID (0 - x)
	  : 
	˵ͣʱ
*/
void PauseTimer(uint8_t _id)
{
	g_Tmr[_id].run=0;
}

/*******************************************************************************
	ResumeTimer
	  : ʱID (0 - 3)
	  : 
	˵ָʱ
*/
void ResumeTimer(uint8_t _id)
{
	g_Tmr[_id].run=1;
}

