#include "tof.h"
#include "vl53l1x.h"
#include "gattprofile.h"
#include "CONFIG.h"
	uint8_t tof_inited=0;	//tofʼ־
	uint8_t errorCounter=0;

//洢 ǰtask id ȫֱ
tmosTaskID  tof_task_id = INVALID_TASK_ID;


//taskeventص,Ҫעtaskʱ,ȥ
static uint16_t tof_task_process_event( uint8_t task_id, uint16_t events ) 
{
	//event 
    if(events & TOF_TASK_TMOS_EVT_TEST_1) 
    {
        GetTofDS();
			tmos_start_task(tof_task_id,TOF_TASK_TMOS_EVT_TEST_1,800);	
        return (events ^ TOF_TASK_TMOS_EVT_TEST_1); //ķʽ¼б־δе¼־  
						
    }
return 0;
}

void TOF_Init(void)
{
	i2c_init(1);	//ʼi2c ˿1
	if (!init(FALSE))	//ʼvl53l1x
	{
		printf("Init TOF failed.\r\n");
		return ;
	}
	setDistanceMode(Medium);
  setMeasurementTimingBudget(50000);
	startContinuous(100);
	
	tof_task_id  = TMOS_ProcessEventRegister( tof_task_process_event );
	//ʼһʱevent
	tmos_start_task(tof_task_id,TOF_TASK_TMOS_EVT_TEST_1,400);			//400*625uS = 250mS
	
}



void GetTofDS(void)
{
	uint16_t t;
	RangeStatus status;
	status=read(TRUE,&t);
	//PRINT("status:%d-%d\r\n",status,ranging_data.range_mm); 
	simpleProfileChar4.stature_status=status;
	simpleProfileChar4.stature_hight=HI_UINT16(ranging_data.range_mm);
	simpleProfileChar4.stature_low=LO_UINT16(ranging_data.range_mm);
	//DS_TOF=t;

}
