#include "weight.h"

uint8_t spi_buffer[SPI_BUFFER_SIZE];
void SPI_SlaveDMARecv( PUINT8 pbuf, UINT16 len)
{
    R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR;  				                                    //fifo
    R16_SPI0_DMA_BEG = (UINT32)pbuf;                                           				//DMA׵ַ
    R16_SPI0_DMA_END = (UINT32)(pbuf + len); 																					//DMAβַ
    R16_SPI0_TOTAL_CNT = len; 																												//DMAַ
    R8_SPI0_INT_FLAG = RB_SPI_IF_CNT_END|RB_SPI_IF_DMA_END;														//жϱ־   ȫ    DMA
		R8_SPI0_INTER_EN	= RB_SPI_IE_DMA_END | RB_SPI_IE_CNT_END;												//жԴ    ȫ    DMA
    R8_SPI0_CTRL_CFG |= RB_SPI_DMA_ENABLE;																						//DMAʹ
    //while(!(R8_SPI0_INT_FLAG & RB_SPI_IF_CNT_END));
    //R8_SPI0_CTRL_CFG &= ~RB_SPI_DMA_ENABLE;
		NVIC_EnableIRQ(SPI0_IRQn);
}


void SPI0_IRQHandler (void)
{
	if (R8_SPI0_INT_FLAG & RB_SPI_IF_CNT_END)
	{
		R8_SPI0_INT_FLAG = RB_SPI_IF_CNT_END;																							//ȫжϱ־
		PRINT("SPI:RB_SPI_IF_CNT_END\r\n");
	}
		if (R8_SPI0_INT_FLAG & RB_SPI_IF_DMA_END)
	{
		R8_SPI0_INT_FLAG = RB_SPI_IF_DMA_END;																							//DMAжϱ־
		PRINT("SPI:RB_SPI_IF_DMA_END\r\n");
	}
}



void SPI0_Init(void)
{
	//uint8_t i;
	GPIOA_ModeCfg(GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15, GPIO_ModeIN_PU);
  SPI0_SlaveInit(); 
	SPI_SlaveDMARecv(spi_buffer,SPI_BUFFER_SIZE);
  //i = SPI0_SlaveRecvByte();
	//    SPI0_SlaveRecv( spiBuffrev, 9 );
  //  SPI0_SlaveTrans( spiBuffrev, 12 );  
}
